BWParser Class Reference

the main class to read a BeagleWorks file More...

`#include <BWParser.hxx>`

Inheritance diagram for BWParser:

## Public Member Functions

| BWParser (MWAWInputStreamPtr input, MWAWRSRCParserPtr rsrcParser, MWAWHeader *header)
| constructor More...
virtual | ~BWParser ()
| destructor More...
bool | checkHeader (MWAWHeader *header, bool strict=false)
| checks if the document header is correct (or not) More...
void | parse (WPXDocumentInterface *documentInterface)
| virtual function used to parse the input More...
Public Member Functions inherited from MWAWParser
virtual | ~MWAWParser ()
| virtual destructor More...
int | version () const
| returns the works version More...
void | setVersion (int vers)
| sets the works version More...

## Protected Member Functions

void | init ()
| inits all internal variables More...
void | createDocument (WPXDocumentInterface *documentInterface)
| creates the listener which will be associated to the document More...
Vec2f | getPageLeftTop () const
| returns the page left top point ( in inches) More...
void | newPage (int number)
| adds a new page More...
bool | sendFrame (int pId)
| try to insert the pId picture (as char) More...
bool | createZones ()
| finds the different objects zones More...
bool | readRSRCZones ()
| read the resource fork zone More...
bool | sendPageFrames ()
| try to send the page graphic More...
bool | sendFrame (BWParserInternal::Frame const &frame)
| try to send a frame More...
bool | sendPicture (int pId, MWAWPosition const &pos, WPXPropertyList frameExtras=WPXPropertyList())
| try to send a picture More...
bool | readPrintInfo ()
| read the print info zone More...
bool | readFrame (MWAWEntry const &entry)
| read a frame zone More...
bool | readLastZone ()
| read the last zone More...
bool | readwPos (MWAWEntry const &entry)
| read the windows positions ( wPos 1001 resource block ) More...
bool | readFontStyle (MWAWEntry const &entry)
| read the font style ressource More...
MWAWInputStreamPtr | rsrcInput ()
| return the input input More...
libmwaw::DebugFile & | rsrcAscii ()
| a DebugFile used to write what we recognize when we parse the document in rsrc More...
Protected Member Functions inherited from MWAWParser
| MWAWParser (MWAWInputStreamPtr input, MWAWRSRCParserPtr rsrcParser, MWAWHeader *header)
| constructor (protected) More...
| MWAWParser (MWAWParserStatePtr state)
| constructor using a state More...
MWAWParserStatePtr | getParserState ()
| returns the parser state More...
MWAWHeader * | getHeader ()
| returns the header More...
MWAWInputStreamPtr & | getInput ()
| returns the actual input More...
MWAWContentListenerPtr & | getListener ()
| returns the listener More...
MWAWPageSpan const & | getPageSpan () const
| returns the actual page dimension More...
MWAWPageSpan & | getPageSpan ()
| returns the actual page dimension More...
double | getFormLength () const
| returns the form length More...
double | getFormWidth () const
| returns the form width More...
double | getPageLength () const
| returns the page length (form length without margin ) More...
double | getPageWidth () const
| returns the page width (form width without margin ) More...
MWAWRSRCParserPtr & | getRSRCParser ()
| returns the rsrc parser More...
void | setListener (MWAWContentListenerPtr &listener)
| sets the listener More...
void | resetListener ()
| resets the listener More...
MWAWFontConverterPtr & | getFontConverter ()
| returns the font converter More...
void | setFontConverter (MWAWFontConverterPtr fontConverter)
| sets the font convertor More...
libmwaw::DebugFile & | ascii ()
| a DebugFile used to write what we recognize when we parse the document More...
void | setAsciiName (char const *name)
| Debugging: change the default ascii file. More...
std::string const & | asciiName () const
| return the ascii file name More...

## Protected Attributes

shared_ptr < BWParserInternal::State > | m_state
| the state More...
shared_ptr< BWText > | m_textParser
| the text parser More...

## Friends

class | BWText

## Detailed Description

the main class to read a BeagleWorks file

## Constructor & Destructor Documentation

BWParser::BWParser | ( | MWAWInputStreamPtr | input,
|  | MWAWRSRCParserPtr | rsrcParser,
|  | MWAWHeader * | header
| ) |  |

constructor

BWParser::~BWParser | ( |  | ) |

virtual

destructor

## Member Function Documentation

bool BWParser::checkHeader | ( | MWAWHeader * | header,
|  | bool | strict = `false`
| ) |  |

virtual

checks if the document header is correct (or not)

Implements MWAWParser.

Referenced by parse().

void BWParser::createDocument | ( | WPXDocumentInterface * | documentInterface | ) |

protected

creates the listener which will be associated to the document

Referenced by parse().

bool BWParser::createZones | ( |  | ) |

protected

finds the different objects zones

Referenced by parse().

Vec2f BWParser::getPageLeftTop | ( |  | ) | const

protected

returns the page left top point ( in inches)

void BWParser::init | ( |  | ) |

protected

inits all internal variables

Referenced by BWParser().

void BWParser::newPage | ( | int | number | ) |

protected

adds a new page

Referenced by BWText::sendText().

void BWParser::parse | ( | WPXDocumentInterface * | documentInterface | ) |

virtual

virtual function used to parse the input

Implements MWAWParser.

bool BWParser::readFontStyle | ( | MWAWEntry const & | entry | ) |

protected

read the font style ressource

Referenced by readRSRCZones().

bool BWParser::readFrame | ( | MWAWEntry const & | entry | ) |

protected

read a frame zone

Referenced by createZones().

bool BWParser::readLastZone | ( |  | ) |

protected

read the last zone

Referenced by createZones().

bool BWParser::readPrintInfo | ( |  | ) |

protected

read the print info zone

Referenced by checkHeader(), and createZones().

bool BWParser::readRSRCZones | ( |  | ) |

protected

read the resource fork zone

Referenced by createZones().

bool BWParser::readwPos | ( | MWAWEntry const & | entry | ) |

protected

read the windows positions ( wPos 1001 resource block )

Referenced by readRSRCZones().

libmwaw::DebugFile & BWParser::rsrcAscii | ( |  | ) |

protected

a DebugFile used to write what we recognize when we parse the document in rsrc

Referenced by readFontStyle(), and readwPos().

MWAWInputStreamPtr BWParser::rsrcInput | ( |  | ) |

protected

return the input input

Referenced by readFontStyle(), and readwPos().

bool BWParser::sendFrame | ( | int | pId | ) |

protected

try to insert the pId picture (as char)

Referenced by sendPageFrames(), and BWText::sendText().

bool BWParser::sendFrame | ( | BWParserInternal::Frame const & | frame | ) |

protected

try to send a frame

bool BWParser::sendPageFrames | ( |  | ) |

protected

try to send the page graphic

Referenced by parse().

bool BWParser::sendPicture | ( | int | pId,
|  | MWAWPosition const & | pos,
|  | WPXPropertyList | frameExtras = `WPXPropertyList()`
| ) |  |

protected

try to send a picture

Referenced by sendFrame().

## Friends And Related Function Documentation

friend class BWText

friend

Referenced by init().

## Member Data Documentation

shared_ptr<BWParserInternal::State> BWParser::m_state

protected

the state

Referenced by checkHeader(), createDocument(), createZones(), getPageLeftTop(), init(), newPage(), readFrame(), sendFrame(), and sendPageFrames().

shared_ptr<BWText> BWParser::m_textParser

protected

the text parser

Referenced by createDocument(), createZones(), init(), and parse().

The documentation for this class was generated from the following files:

- BWParser.hxx
- BWParser.cxx